import java.util.Scanner;

public class DemoArrayOfArray {

   public double[][] createMatrix(int n, int m) {
      double[][] matrix = new double[n][];
      for(int row = 0; row < matrix.length; ++row) {
	 matrix[row] = new double[m];
      }
      return matrix;
   }

   public void fillMatrix(double[][] matrix) {
      if (matrix != null) {
	 for(int row = 0; row < matrix.length; ++row) {
	    if (matrix[row] != null) {
	       for(int column = 0; column < matrix[row].length; ++column) {
		  matrix[row][column] = Math.random() * 10;
	       }
	    }
	 }
      }
   }

   public void printMatrix(double[][] matrix) {
      if (matrix != null) {
	 for(int row = 0; row < matrix.length; ++row) {
	    if (matrix[row] != null) {
	       for(int column = 0; column < matrix[row].length; ++column) {
		  final String space = column > 0 ? " " : "";
		  System.out.printf("%s%4.1f", space, matrix[row][column]);
	       }
	       System.out.println(""); //print new line after row end
	    }
	 }
      }
   }

   public double[][] sum(double[][] m1, double[][] m2) {
      double[][] sum = null;
      if (
	    m1 != null && m2 != null && 
	    m1.length == m2.length
	 ) {
	 sum = new double[m1.length][];
	 for(int r = 0; r < m1.length; ++r) {
	    if (m1[r] != null && m2[r] != null && m1[r].length == m2[r].length) {
	       sum[r] = new double[m1[r].length];
	       for(int c = 0; c < m1[r].length; ++c) {
		  sum[r][c] = m1[r][c] + m2[r][c];
	       }
	    } else {
	       System.err.println("Error: matrix dimensions does not match!");
	       sum = null;
	       break;
	    }
	 }
	 }
      return sum;
   }

   public static void main(String[] args) {
      final int N = 3;
      final int M = 4;
      DemoArrayOfArray demo = new DemoArrayOfArray();
      double[][] matrix = demo.createMatrix(N, M);

      System.out.println("Matrix after initialization:");
      demo.printMatrix(matrix);
      demo.fillMatrix(matrix);

      System.out.println("\nFirst matrix:");
      demo.printMatrix(matrix);

      System.out.println("\nSecond matrix:");
      double[][] matrix2 = demo.createMatrix(N, M);
      demo.fillMatrix(matrix2);
      demo.printMatrix(matrix2);

      System.out.println("\nSum of matrices");
      double[][] sum = demo.sum(matrix, matrix2);
      demo.printMatrix(sum);
   }

}
