import java.util.Scanner;
import java.io.FileReader;
import java.io.FileNotFoundException;

public class DemoArrayString {

   public String[] loadLines(int numberOfLines, String filename) {
      String lines[] = new String[numberOfLines];
      try {
         Scanner scanner = new Scanner(new FileReader(filename));
         for(int i = 0; i < lines.length; ++i) {
            lines[i] = scanner.nextLine();
            System.err.println("Info: line[" + i + "]: " + lines[i]);
         }
      } catch (FileNotFoundException e) {
         System.err.println("Error: filename '" + filename + "' not found!");
      }
      return lines;
   }

   public void printWordOccurrance(String[] lines, String word) {
      String wordOccurace = "";
      int counter = 0;
      for(int i = 0; i < lines.length; ++i) {
         if (lines[i] != null && lines[i].indexOf(word) != -1) {
            counter += 1;
            wordOccurace += " " + i;
         }
      }
      if (counter > 0) {
         System.out.println("Work '" + word + "' detected in " + counter + " lines: " +  wordOccurace);
      } else {
         System.out.println("Word '" + word + "' has zero occurrence in the input lines");
      }
   }

   public static void main(String[] args) {
      final String FILENAME = "lines.txt";
      final int NUMBER_OF_LINES = 5;
      DemoArrayString demo = new DemoArrayString();
      Scanner scanner = new Scanner(System.in);

      String[] lines = demo.loadLines(NUMBER_OF_LINES, (args.length > 0 ? args[0] : FILENAME));

      String word = "";
      do {
         System.err.print("Enter a word: ");
         System.err.flush();
         word = scanner.nextLine();
         if (word.length() > 0) {
            demo.printWordOccurrance(lines, word);
         }
      } while (word != null && word.length() > 0);
   }

}
